summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorRichard Maw <richard.maw@codethink.co.uk>2012-04-23 15:23:01 +0000
committerRichard Maw <richard.maw@codethink.co.uk>2012-04-23 15:47:19 +0000
commitd210fb09bb0becb69975e92f42d16260d4d23933 (patch)
treee6a21bdd5938273c8b2082c3c45bbf15f341a9cb /tests
parent8a653a535f41249cf0b5cea098a3ca65641962a2 (diff)
downloadmorph-d210fb09bb0becb69975e92f42d16260d4d23933.tar.gz
tests: add test for build-system: cpan
This does some horrible output mangling because where you install perl modules depends on how your perl was compiled and its version. This will still probably fail on some machines
Diffstat (limited to 'tests')
-rwxr-xr-xtests/build-system-cpan.script73
-rw-r--r--tests/build-system-cpan.stdout19
2 files changed, 92 insertions, 0 deletions
diff --git a/tests/build-system-cpan.script b/tests/build-system-cpan.script
new file mode 100755
index 00000000..cce7eb36
--- /dev/null
+++ b/tests/build-system-cpan.script
@@ -0,0 +1,73 @@
+#!/bin/sh
+#
+# Convert the hello-chunk project to perl with CPAN
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+chunkrepo="$DATADIR/chunk-repo"
+cd "$chunkrepo"
+
+git checkout --quiet farrokh
+
+git rm --quiet hello.c
+
+cat <<EOF >hello
+#!/usr/bin/perl
+print "hello, world\n"
+EOF
+git add hello
+
+cat <<EOF >Makefile.PL
+use strict;
+use warnings;
+use ExtUtils::MakeMaker;
+WriteMakefile(
+ EXE_FILES => ['hello'],
+)
+EOF
+git add Makefile.PL
+
+cat <<EOF >hello.morph
+{
+ "name": "hello",
+ "kind": "chunk",
+ "build-system": "cpan"
+}
+EOF
+git add hello.morph
+
+git commit --quiet -m 'convert hello into a perl cpan project'
+
+"$SRCDIR/scripts/test-morph" build chunk-repo farrokh hello.morph
+
+TEMPEXTRACT="$DATADIR/cpanextract"
+mkdir -p "$TEMPEXTRACT"
+
+PERLVERSION=`perl -e 'print $^V' | sed 's|^v\(.*\)|\1|'`
+PERLMAJOR=`perl -e 'print $^V' | sed 's|^v\([^\.]*\)\.[^\.]*\.[^\.]*$|\1|'`
+ARCH=`perl -V | grep archname | sed 's|^.*archname=\(\S*\).*$|\1|'`
+
+for chunk in "$DATADIR/cache/"*.chunk.*
+do
+ echo "$chunk:" | sed 's/[^.]*//'
+ tar -tf "$chunk" | LC_ALL=C sort |
+ sed -e '/^\.\/./s:^\./::' \
+ -e s/"$ARCH"/ARCH/ \
+ -e s/perl"$PERLMAJOR"/PERLDIR/ \
+ -e s/"$PERLVERSION"/PERLVERSION/
+done
diff --git a/tests/build-system-cpan.stdout b/tests/build-system-cpan.stdout
new file mode 100644
index 00000000..e6e093cc
--- /dev/null
+++ b/tests/build-system-cpan.stdout
@@ -0,0 +1,19 @@
+arch=x86_64-linux major=5 version=5.14.2
+.chunk.hello:
+./
+baserock/
+baserock/hello.meta
+usr/
+usr/bin/
+usr/bin/hello
+usr/lib/
+usr/lib/PERLDIR/
+usr/lib/PERLDIR/PERLVERSION/
+usr/lib/PERLDIR/PERLVERSION/ARCH/
+usr/lib/PERLDIR/PERLVERSION/ARCH/perllocal.pod
+usr/lib/PERLDIR/site_perl/
+usr/lib/PERLDIR/site_perl/PERLVERSION/
+usr/lib/PERLDIR/site_perl/PERLVERSION/ARCH/
+usr/lib/PERLDIR/site_perl/PERLVERSION/ARCH/auto/
+usr/lib/PERLDIR/site_perl/PERLVERSION/ARCH/auto/hello.build/
+usr/lib/PERLDIR/site_perl/PERLVERSION/ARCH/auto/hello.build/.packlist